/*
 * $Id: numlist2.h,v 0.2 1991/08/30 10:17:52 ceder Exp $
 *
 * File: numlist2.h
 * 
 * This file is supposed to be a reference while testing numlist.
 *
 * Author: Inge Wallin
 */


#ifndef NUMLIST2__H
#define NUMLIST2__H

#include <sys/types.h>


#define NUMLIST_ERR      0xffffffff

#define MAX_NUMS   131072
#define NUM_CELLS  (MAX_NUMS / 32)

typedef struct {
    u_long   cells[NUM_CELLS];
} Numlist;


Numlist *numlist_create(void);
Bool     numlist_isempty(Numlist *);
Bool     numlist_member(Numlist *, u_long);
u_long   numlist_first(Numlist *);
u_long   numlist_next(Numlist *, u_long);
void     numlist_insert(Numlist *, u_long);
void     numlist_delete(Numlist *, u_long);


#endif   /* NUMLIST2__H */
